"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handleServerError = handleServerError;
exports["default"] = exports.GLOBAL_SERVER_ERROR = void 0;

var _actionCreators = require("../../reducers/data/actionCreators");

var _errorCodes = require("./errorCodes");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var GLOBAL_SERVER_ERROR = 'Server error. Try to to refresh the page.';
exports.GLOBAL_SERVER_ERROR = GLOBAL_SERVER_ERROR;

function handleServerError(reducer, error, config) {
  var _reducer = _slicedToArray(reducer, 2),
      data = _reducer[0],
      dispatch = _reducer[1];

  var state = {
    data: data
  };
  var handleFail = config.handleFail;
  var globalServerError = config.globalServerError || GLOBAL_SERVER_ERROR;
  var errors = [{
    global: [globalServerError]
  }, {
    data: [error.stack]
  }];
  var payload = {
    error_type: _errorCodes.SERVER_ERROR,
    errors: errors,
    ok: false,
    status: 500
  };
  var failAction = (0, _actionCreators.failData)(payload, config);
  dispatch(failAction);

  if (handleFail) {
    var action = {
      config: config,
      payload: payload,
      type: failAction.type
    };
    handleFail(state, action);
  }
}

var _default = handleServerError;
exports["default"] = _default;