"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getNormalizedDeletedState = getNormalizedDeletedState;
exports["default"] = void 0;

var _getUnifiedData = _interopRequireWildcard(require("./getUnifiedData"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function getNormalizedDeletedState(state, patch, config) {
  var getDatumIdValue = config.getDatumIdValue || _getUnifiedData.getDefaultDatumIdValue;
  var nextState = config.nextState || {};
  Object.keys(patch).forEach(function (patchKey) {
    var data = patch[patchKey];

    if (!data) {
      return;
    }

    var nextData = (0, _getUnifiedData["default"])(data, config);
    var previousData = state[patchKey];

    if (!previousData) {
      nextState[patchKey] = nextData;
      return;
    }

    var nextDataIds = nextData.map(getDatumIdValue);
    var resolvedData = previousData.filter(function (previousDatum) {
      return !nextDataIds.includes(getDatumIdValue(previousDatum));
    });
    nextState[patchKey] = resolvedData;
  });
  return nextState;
}

var _default = getNormalizedDeletedState;
exports["default"] = _default;