"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getNormalizedSuccessState = getNormalizedSuccessState;
exports["default"] = exports.activitiesWithDeprecationInfoFrom = exports.remoteDiffFrom = exports.deprecatedActivitiesFrom = void 0;

var _getActivateState = _interopRequireWildcard(require("./getActivateState"));

var _getSuccessState = _interopRequireDefault(require("./getSuccessState"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var deprecatedActivitiesFrom = function deprecatedActivitiesFrom(activities) {
  return activities.filter(function (activity) {
    return !activity.deprecation || Object.keys(activity.deprecation).length === 0;
  });
};

exports.deprecatedActivitiesFrom = deprecatedActivitiesFrom;

function intersect(a, b) {
  var setA = new Set(a);
  var setB = new Set(b);
  var intersection = new Set(_toConsumableArray(setA).filter(function (x) {
    return setB.has(x);
  }));
  return Array.from(intersection);
}

var remoteDiffFrom = function remoteDiffFrom(previousEntity, nextEntity) {
  var remoteDiff = {};
  var previousEntityRemote = previousEntity.__remote__ || {};
  var nextEntityRemote = nextEntity.__remote__ || {};
  var sharedKeys = intersect(Object.keys(previousEntityRemote), Object.keys(nextEntityRemote));
  sharedKeys.forEach(function (key) {
    if (['__remote__', 'dateModified'].includes(key)) return;
    var previousRemoteValue = previousEntityRemote[key];
    var nextRemoteValue = nextEntityRemote[key];

    if (previousRemoteValue !== nextRemoteValue) {
      remoteDiff[key] = {
        previous: previousRemoteValue,
        next: nextRemoteValue
      };
    }
  });
  return remoteDiff;
};

exports.remoteDiffFrom = remoteDiffFrom;

var activitiesWithDeprecationInfoFrom = function activitiesWithDeprecationInfoFrom(activities, previousEntitiesByActivityIdentifier, nextEntitiesByActivityIdentifier) {
  return activities.map(function (activity) {
    var activityWithDeprecationInfo = _objectSpread({
      deprecation: null,
      bothLocalAndRemoteEntityHaveBeenModified: false
    }, activity);

    var previousEntity = previousEntitiesByActivityIdentifier[activity.entityIdentifier];
    var nextEntity = nextEntitiesByActivityIdentifier[activity.entityIdentifier];

    if (nextEntity && nextEntity.__remote__ && nextEntity.__remote__.dateModified && nextEntity.__remote__.dateModified > activity.dateCreated) {
      activityWithDeprecationInfo.bothLocalAndRemoteEntityHaveBeenModified = true;
      var remoteDiff = remoteDiffFrom(previousEntity, nextEntity);
      var deprecation = {};
      Object.keys(activity.patch).forEach(function (key) {
        if (remoteDiff[key]) {
          deprecation[key] = remoteDiff[key];
        }
      });

      if (Object.keys(deprecation).length > 0) {
        activityWithDeprecationInfo.deprecation = deprecation;
      }
    }

    return activityWithDeprecationInfo;
  });
};

exports.activitiesWithDeprecationInfoFrom = activitiesWithDeprecationInfoFrom;

function getNormalizedSuccessState(state, action) {
  var successState = (0, _getSuccessState["default"])(state, action);
  var nextState = state;

  if (Object.keys(successState).length) {
    nextState = _objectSpread(_objectSpread({}, state), successState);

    if (state.__activities__) {
      var previousEntitiesByActivityIdentifier = (0, _getActivateState.entitiesByActivityIdentifierFrom)(state, state.__activities__);
      var nextEntitiesByActivityIdentifier = (0, _getActivateState.entitiesByActivityIdentifierFrom)(nextState, state.__activities__);
      nextState.__activities__ = activitiesWithDeprecationInfoFrom(state.__activities__, previousEntitiesByActivityIdentifier, nextEntitiesByActivityIdentifier);
      var notDeprecatedActivities = deprecatedActivitiesFrom(nextState.__activities__);

      var _dateCreatedAndModifi = (0, _getActivateState.dateCreatedAndModifiedsByEntityIdentifierFrom)(state, notDeprecatedActivities, nextEntitiesByActivityIdentifier),
          entityDateCreatedsByIdentifier = _dateCreatedAndModifi.entityDateCreatedsByIdentifier,
          entityDateModifiedsByIdentifier = _dateCreatedAndModifi.entityDateModifiedsByIdentifier;

      nextState = (0, _getActivateState["default"])(nextState, notDeprecatedActivities, {
        entityDateCreatedsByIdentifier: entityDateCreatedsByIdentifier,
        entityDateModifiedsByIdentifier: entityDateModifiedsByIdentifier
      });
    }
  }

  if (action.config.deleteRequestedActivities) {
    var localIdentifiersOfActivitiesToBeDeleted = action.config.body.map(function (a) {
      return a.localIdentifier;
    });
    nextState.__activities__ = nextState.__activities__.filter(function (a) {
      return !localIdentifiersOfActivitiesToBeDeleted.includes(a.localIdentifier);
    });
  }

  return nextState;
}

var _default = getNormalizedSuccessState;
exports["default"] = _default;