"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.successData = exports.setData = exports.reinitializeData = exports.requestActivities = exports.requestData = exports.purgeData = exports.mergeData = exports.failData = exports.deleteData = exports.assignData = exports.activateData = void 0;

var _getConfigWithDefaultValues = _interopRequireDefault(require("../../fetch/getConfigWithDefaultValues"));

var _actions = require("./actions");

var _getTypeSuffixFromConfig = _interopRequireDefault(require("./getTypeSuffixFromConfig"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var activateData = function activateData(activities) {
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return {
    activities: activities,
    config: config,
    type: _actions.ACTIVATE_DATA
  };
};

exports.activateData = activateData;

var assignData = function assignData(patch) {
  return {
    patch: patch,
    type: _actions.ASSIGN_DATA
  };
};

exports.assignData = assignData;

var deleteData = function deleteData(patch) {
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return {
    config: config,
    patch: patch,
    type: _actions.DELETE_DATA
  };
};

exports.deleteData = deleteData;

var failData = function failData() {
  var payload = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return {
    config: config,
    payload: payload,
    type: "FAIL_DATA_".concat((0, _getTypeSuffixFromConfig["default"])(config))
  };
};

exports.failData = failData;

var mergeData = function mergeData(patch) {
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return {
    config: config,
    patch: patch,
    type: _actions.MERGE_DATA
  };
};

exports.mergeData = mergeData;

var purgeData = function purgeData(key) {
  return {
    key: key,
    result: function result() {
      return null;
    },
    type: 'persist/PURGE'
  };
};

exports.purgeData = purgeData;

var requestData = function requestData() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var configWithDefaultValues = (0, _getConfigWithDefaultValues["default"])(config);
  return {
    config: configWithDefaultValues,
    type: "REQUEST_DATA_".concat((0, _getTypeSuffixFromConfig["default"])(configWithDefaultValues))
  };
};

exports.requestData = requestData;

var requestActivities = function requestActivities(config) {
  return requestData(_objectSpread(_objectSpread({}, config), {}, {
    deleteRequestedActivities: true
  }));
};

exports.requestActivities = requestActivities;

var reinitializeData = function reinitializeData() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return {
    config: config,
    type: _actions.REINITIALIZE_DATA
  };
};

exports.reinitializeData = reinitializeData;

var setData = function setData(patch) {
  return {
    patch: patch,
    type: _actions.SET_DATA
  };
};

exports.setData = setData;

var successData = function successData() {
  var payload = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return {
    config: config,
    payload: payload,
    type: "SUCCESS_DATA_".concat((0, _getTypeSuffixFromConfig["default"])(config))
  };
};

exports.successData = successData;