"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.selectEntityByKeyAndNormalizer = void 0;

var _reReselect = _interopRequireDefault(require("re-reselect"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var mapArgsToCacheKey = function mapArgsToCacheKey(state, key, normalizer) {
  return "".concat(key || '').concat(normalizer.stateKey || '').concat(normalizer.datumKey || '');
};

var selectEntityByKeyAndNormalizer = (0, _reReselect["default"])(function (state, key) {
  return state.data[key];
}, function (state, key, normalizer) {
  return normalizer.stateKey;
}, function (state, key, normalizer) {
  return normalizer.datumKey;
}, function (entities, stateKey, datumKey) {
  return (entities || []).find(function (entity) {
    if (!entity.__normalizers__) return undefined;
    return entity.__normalizers__.find(function (normalizer) {
      return normalizer.stateKey === stateKey && normalizer.datumKey === datumKey;
    });
  });
})(mapArgsToCacheKey);
exports.selectEntityByKeyAndNormalizer = selectEntityByKeyAndNormalizer;
var _default = selectEntityByKeyAndNormalizer;
exports["default"] = _default;